from asyncio import *
import keyboard
import tkinter as tk   
from datetime import datetime

flgs = {}         #    コルーチンの状態
ck_state = 0      #    時計の状態

def Check_CRs():
    """
           コルーチンのチェック
    """
    ck_end = True
    vals = flgs.values()
    for val in vals:
        if val == False:
            ck_end = False
    if ck_end:              #   すべてのコルーチンが終了しておれば実行
        loop.stop()         #   イベントループのストップ


async def check_key():
    """
           押されたキーに応じて時計の状態を設定
    """
    global ck_state
    flgs['ck'] = False
    while True:
        if keyboard.is_pressed('q'): #   このコルーチンの終了
            break
        if keyboard.is_pressed('0'): #   すべての時計を邱氏
            ck_state = 0
        if keyboard.is_pressed('1'): #    時計１を動かす
            ck_state = 1
        if keyboard.is_pressed('2'): #    時計２を動かす
            ck_state = 2
        if keyboard.is_pressed('3'): #    すべての時計を動かす
            ck_state = 3
        await sleep(0)               #   他のコルーチンへ実行を移す
        
    flgs['ck'] = True   #   このコルーチンの終了を記録 
    Check_CRs()         #   すべてのコルーチンの終了をチェック


async def myclock(id):
    global ck_state
    flgs[id] = False
    root = tk.Tk()
    root.title(f'Clock-{id}')
    cnvs = tk.Canvas(root, width = 500, height = 200, background = '#00ffff')
    cnvs.pack()
    cnvs.create_text(250, 100, text = '', font = ('', 50), fill = 'blue',
                     tags = 'MyText')
    while True:
        if ck_state in set([id, 3]):    #   時刻の表示
            now = datetime.now()
            s = '{0:0>2d}:{1:0>2d}:{2:0>2d}'.format(
                now.hour, now.minute, now.second)
            cnvs.itemconfig('MyText', text = s)
        else:                            #   休憩の表示 
            cnvs.itemconfig('MyText', text = '休憩中')
        cnvs.update()
        if flgs['ck'] == True:     #   このプログラムの終了をチェック
            flgs[id] = True        #   このコルーチンの終了を記録
            break
        await sleep(0)                  #   他のコルーチンへ実行を移す
    Check_CRs()           #   すべてのコルーチンの終了チェック
    root.destroy()
        
        

loop = get_event_loop()
ensure_future(check_key())      #   check_key()実行のスケジュール
ensure_future(myclock(1))       #   myclock(1)実行のスケジュール
ensure_future(myclock(2))       #   myclock(2)実行のスケジュール

try:
    loop.run_forever()          #   イベントループをstop()が呼び出されるまで実行し続ける
finally:
    loop.close()                #   イベントループを閉じる
                    
